do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt)
      self:move()
      self:shootAuto()
      self:shootTimer()
      self:knockback()
      self:updateAnimate(dt)
      self.x = math.ceil(self.x)
      self.y = math.ceil(self.y)
      return _parent_0.update(self, self)
    end,
    draw = function(self)
      self:drawAnimate()
      return _parent_0.draw(self, self)
    end,
    keypressed = function(self, key)
      self:shootSingle(key)
      self:dodge(key)
      self:interact(key)
      if key == "i" then
        for k, v in pairs(PlayerManager.inventory) do
          print(k, v, v.quantity, v.type)
        end
      end
    end,
    destroy = function(self) end,
    updateAnimate = function(self, dt)
      if self.dir.ver == -1 or self.shooting then
        return self.anim.idle_up:update(dt)
      elseif self.dir.ver == 1 or self.dir.ver == 0 then
        return self.anim.idle_down:update(dt)
      end
    end,
    drawAnimate = function(self)
      if self.dir.ver == -1 or self.shooting then
        love.graphics.setColor(255, 255, 255)
        self.anim.idle_up:draw(self.sheet, self.x - 20, self.y - 20)
        love.graphics.setColor(0, 0, 0, 30)
        return self.anim.idle_up:draw(self.sheet, self.x - 20, self.y + 167, 0, 1, -0.5)
      elseif self.dir.ver == 1 or self.dir.ver == 0 then
        love.graphics.setColor(255, 255, 255)
        self.anim.idle_down:draw(self.sheet, self.x - 20, self.y - 20)
        love.graphics.setColor(0, 0, 0, 30)
        return self.anim.idle_down:draw(self.sheet, self.x - 20, self.y + 167, 0, 1, -0.5)
      end
    end,
    move = function(self)
      if not self.dodging then
        if not self.talking then
          if mad.input:key("left") then
            self.hsp = -self.spd
            self.dir.hor = -1
          end
          if mad.input:key("right") then
            self.hsp = self.spd
            self.dir.hor = 1
          end
          if mad.input:key("up") then
            self.vsp = -self.spd
            self.dir.ver = -1
          end
          if mad.input:key("down") then
            self.vsp = self.spd
            self.dir.ver = 1
          end
          self.x = self.x + self.hsp
          self.y = self.y + self.vsp
          if not mad.input:key("left") and not mad.input:key("right") then
            self.dir.hor = 0
            self.hsp = 0
          end
          if not mad.input:key("up") and not mad.input:key("down") then
            self.dir.ver = 0
            self.vsp = 0
          end
          if self.talking then
            self.hsp = 0
            self.vsp = 0
          end
        end
      else
        if self.dir.ver == -1 then
          self.y = self.y - (self.spd * 3.5)
        elseif self.dir.ver == 1 then
          self.y = self.y + (self.spd * 3.5)
        end
        if self.dir.hor == -1 then
          self.x = self.x - (self.spd * 3.5)
        elseif self.dir.hor == 1 then
          self.x = self.x + (self.spd * 3.5)
        end
      end
      if self.dodge_timer > 0 then
        self.dodge_timer = self.dodge_timer - 1
      else
        self.dodging = false
      end
    end,
    dodge = function(self, key)
      self.key = key
      if self.key == keys.dodge and not self.dodging then
        self.dodging = true
        self.dodge_timer = 6
      end
    end,
    shootAuto = function(self)
      if not self.dodging and not self.talking then
        if PlayerManager.gun_base.ver == "auto" then
          if mad.input:key(keys.shoot) and self.can_shoot then
            for k, v in pairs(PlayerManager.inventory) do
              if v.type == PlayerManager.gun_ammo then
                if v.quantity > 0 then
                  self.hasAmmo = true
                  self.ammo = v
                  break
                elseif v.quantity <= 0 then
                  table.remove(PlayerManager.inventory, k)
                  self.hasAmmo = false
                  break
                end
              end
            end
            if not self.hasAmmo then
              for k, v in pairs(PlayerManager.inventory) do
                if v.type == "Basic" and v.quantity ~= 0 then
                  PlayerManager.gun_ammo = v.type
                  self.hasAmmo = true
                  self.ammo = v
                  break
                end
              end
            end
            if self.hasAmmo then
              mad.object:create(Bullet(PlayerManager.gun_ammo, self.x + self.w / 2 - 16, self.y - 30))
              self.ammo.quantity = self.ammo.quantity - 1
              self.fire_timer = 60 / self.firerate
              self.can_shoot = false
              self.knocking = true
              self.shooting = true
            else
              mad.object:create(TextFlash("no ammo!", self.x, self.y))
            end
          end
          if not mad.input:key(keys.shoot) then
            self.shooting = false
          end
        end
      end
    end,
    shootSingle = function(self)
      if not self.dodging and not self.talking then
        if PlayerManager.gun_base.ver == "single" then
          if mad.input:key(keys.shoot) and self.can_shoot then
            for k, v in pairs(PlayerManager.inventory) do
              if v.type == PlayerManager.gun_ammo then
                if v.quantity > 0 then
                  self.hasAmmo = true
                  self.ammo = v
                  break
                elseif v.quantity <= 0 then
                  table.remove(PlayerManager.inventory, k)
                  self.hasAmmo = false
                  break
                end
              end
            end
            if not self.hasAmmo then
              for k, v in pairs(PlayerManager.inventory) do
                if v.type == "Basic" and v.quantity ~= 0 then
                  PlayerManager.gun_ammo = v.type
                  self.hasAmmo = true
                  self.ammo = v
                  break
                end
              end
            end
            if self.hasAmmo then
              mad.object:create(Bullet(PlayerManager.gun_ammo, self.x + self.w / 2 - 16, self.y - 30))
              self.ammo.quantity = self.ammo.quantity - 1
              self.fire_timer = 30 / self.firerate
              self.can_shoot = false
              self.knocking = true
            else
              return mad.object:create(TextFlash("no ammo!", self.x, self.y))
            end
          end
        end
      end
    end,
    shootTimer = function(self)
      if self.fire_timer > 0 then
        self.fire_timer = self.fire_timer - 1
      else
        self.can_shoot = true
      end
    end,
    knockback = function(self)
      if self.knocking then
        self.y = self.y + self.kickback
        self.kickback_timer = self.kickback_timer - 1
      end
      if self.kickback_timer <= 0 then
        self.knocking = false
        self.kickback_timer = 5
      end
    end,
    interact = function(self, key)
      self.key = key
      if self.key == keys.interact then
        return print("interacted.")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, x, y)
      self.x, self.y = x, y
      self.spd = 4.5
      self.hsp = 0
      self.vsp = 0
      self.firerate = PlayerManager.gun_base.fire_rate
      self.can_shoot = true
      if PlayerManager.gun_base.ver == "auto" then
        self.fire_timer = 60 / self.firerate
      elseif PlayerManager.gun_base.ver == "single" then
        self.fire_timer = 40 / self.firerate
      end
      self.kickback = PlayerManager.gun_grip.kickback
      self.kickback_timer = 6
      self.knocking = false
      self.pattern = PlayerManager.gun_barrel.pattern
      self.sheet, self.grid = mad.sprite:gImg("player_sheet.png", 86, 125)
      self.anim = {
        idle_up = mad.sprite:anim(self.grid, '3-4', 1, 0.3),
        idle_down = mad.sprite:anim(self.grid, '1-2', 1, 0.3)
      }
      self.shooting = false
      self.dodging = false
      self.dodge_timer = 0
      self.dir = {
        hor = 0,
        ver = -1
      }
      self.talking = false
      self.sprite_face = mad.sprite:img("player_sheet.png")
      return _parent_0.__init(self, self, 42, 100, "player", col.player)
    end,
    __base = _base_0,
    __name = "Player",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Player = _class_0
end
